class StickyBall extends Ball {
  boolean following = false;

  StickyBall(int c, color col, float x, float y, float dx, float dy, IBus bus) { super(c,col,x,y,dx,dy,bus); }
  
  void interact(Iterable<IMover> balls ) {
    if (following) { 
      setDX(other.getDX());
      setDY(other.getDY());      
      x=x+getDX();
      y=y+getDY();
    } else {
      x=x+getDX();
      y=y+getDY();

      if (outside(x,400)) { invDX(); }
      if (outside(y,400)) { invDY(); }
      
      for (IMover b2 : balls) {
        if (!(b2==this)) {
          if (PVector.sub(new PVector(b2.getX(),b2.getY()),new PVector(getX(),getY())).mag() < rad) {                      
            if (!((StickyBall)b2).following) {
              following = true;
              other = (Ball)b2;
            }
          }
        }
      }

    } 
    
  }
  
  
  void draw() {
    fill(colour);
    ellipse(x,y,10,10);
    line(x,y,width/2,height/2);
  }  
}



class StickyBalls extends BaseControlAutomaton implements IAutomatonToy {
  
  ArrayList<IMover> balls;

  int no_balls=10;
  PVector centre;
  PVector target;
  int counter;

  StickyBalls(ColorTool ct, IBus bus) {
    centre = new PVector(200,200);  
  
    balls = new ArrayList<IMover>();
    RandomColorGenerator rc = ct.randomColorGenerator(false);
    for (int i=0;i<no_balls;i++) {
      balls.add(new StickyBall(i,rc.next(),random(300)+100,random(300)+100,random(5)+5,random(5)+5, bus));
    }

  }

  void sizeInSetup() { size(400,400); }
  
  void nextStep() {
    for (IMover b : balls) {
      b.interact(balls);
    }    
  }
  
  void draw() {
    background(0);
    for (IMover b : balls) { 
      b.draw();
    }    
  }
  
  void mousePressed(int mouseX, int mouseY) {
    target = new PVector(mouseX,mouseY);
    
    for (int i=0;i<no_balls;i++) {
      Ball b = (Ball)balls.get(i);
      b.head_for(target);
    } 
  }
  void mouseReleased() { }

  void struck(int x, int y) { }
  void mouseDragged(int mouseX, int mouseY) { }
  void reset() {
    // TODO something
  } 
  void keyPressed(int k) { }
  
  String diagnostic() { return "StickyBalls"; }
  
  void postToBus() {
    // TODO something
  }
}
